Option Strict On
Option Explicit On 

Imports System.IO

Module UpdateFiles
    Private Const TIME_DIF_SEC As Integer = 5
    Public Canceled As Boolean

    Public Sub UpdateFilesInSubDirectories(ByVal infDirOrigin As DirectoryInfo, _
                                           ByVal infDirDest As DirectoryInfo, _
                                           ByVal objCallBackTarget As frmFolderSync)
        Dim infOriginSubDirectories() As DirectoryInfo
        UpdateFilesInOneDirectory(infDirOrigin, infDirDest, infOriginSubDirectories, objCallBackTarget)

        If Canceled Then Exit Sub

        Dim infaDirectory As DirectoryInfo
        For Each infaDirectory In infOriginSubDirectories
            Dim infDest As New DirectoryInfo(Path.Combine(infDirDest.FullName, infaDirectory.Name))
            If infDest.Exists Then
                If Not (objCallBackTarget Is Nothing) Then objCallBackTarget.FileOp("[Chck]" & infDest.FullName)
            Else
                If Not (objCallBackTarget Is Nothing) Then objCallBackTarget.FileOp("[Make]" & infDest.FullName)
                infDest.Create()
            End If

            UpdateFilesInSubDirectories(infaDirectory, infDest, objCallBackTarget)

            If Canceled Then Exit Sub
        Next
    End Sub

    Public Sub UpdateFilesInOneDirectory(ByVal infDirOrigin As DirectoryInfo, _
                                         ByVal infDirDest As DirectoryInfo, _
                                         ByRef infSubDirectories() As DirectoryInfo, _
                                         ByVal objCallBackTarget As frmFolderSync)
        infSubDirectories = infDirOrigin.GetDirectories()
        Dim infFiles() As FileInfo = infDirOrigin.GetFiles

        'Copy Mssing Files or Newer Files
        Dim infFile As FileInfo
        For Each infFile In infFiles
            If Canceled Then Exit Sub

            Dim infDestFile As New FileInfo(Path.Combine(infDirDest.FullName, infFile.Name))

            If Not infDestFile.Exists Then
                'Missing File
                If Not (objCallBackTarget Is Nothing) Then objCallBackTarget.FileOp("[Copy]" & infFile.FullName)
                infFile.CopyTo(infDestFile.FullName)
            ElseIf infFile.LastWriteTime > infDestFile.LastWriteTime.AddSeconds(TIME_DIF_SEC) Then
                'File with Newer Time Stamp
                If Not (objCallBackTarget Is Nothing) Then objCallBackTarget.FileOp("[Copy]" & infFile.FullName)
                infFile.CopyTo(infDestFile.FullName, True)
            Else
                If Not (objCallBackTarget Is Nothing) Then objCallBackTarget.FileOp("[Pass]" & infFile.FullName)
            End If
        Next
    End Sub
End Module